From ff9b1446b4eef136bb54cbc8c12006e575b7ed80 Mon Sep 17 00:00:00 2001
From: Chris Lamb <lamby@debian.org>
Date: Sat, 31 Jul 2010 21:15:31 -0400
Subject: Run chroot stage with /var/lib/dpkg mounted as a tmpfs

Idea from Thomas Lange and FAI. Speedup in my testcase (standard image)
is 3m00 => 2m50, probably much better improvements for the desktop image
clients.
---
 scripts/build/chroot            |  2 ++
 scripts/build/chroot_dpkg_tmpfs | 74 +++++++++++++++++++++++++++++++++++++++++
 scripts/build/clean             |  1 +
 3 files changed, 77 insertions(+)
 create mode 100755 scripts/build/chroot_dpkg_tmpfs

diff --git a/scripts/build/chroot b/scripts/build/chroot
index 99f03db..96dbfe7 100755
--- a/scripts/build/chroot
+++ b/scripts/build/chroot
@@ -34,6 +34,7 @@ lh chroot_selinuxfs install ${*}
 lh chroot_sysfs install ${*}
 lh chroot_debianchroot install ${*}
 lh chroot_dpkg install ${*}
+lh chroot_dpkg_tmpfs install ${*}
 lh chroot_sysv-rc install ${*}
 lh chroot_upstart install ${*}
 lh chroot_hosts install ${*}
@@ -71,6 +72,7 @@ lh chroot_resolv remove ${*}
 lh chroot_hosts remove ${*}
 lh chroot_sysv-rc remove ${*}
 lh chroot_upstart remove ${*}
+lh chroot_dpkg_tmpfs remove ${*}
 lh chroot_dpkg remove ${*}
 lh chroot_debianchroot remove ${*}
 lh chroot_sysfs remove ${*}
diff --git a/scripts/build/chroot_dpkg_tmpfs b/scripts/build/chroot_dpkg_tmpfs
new file mode 100755
index 0000000..8d7e264
--- /dev/null
+++ b/scripts/build/chroot_dpkg_tmpfs
@@ -0,0 +1,74 @@
+#!/bin/sh
+
+# lh_chroot_dpkg_tmpfs(1) - manage tmpfs for /var/lib/dpkg
+# Copyright (C) 2006-2010 Daniel Baumann <daniel@debian.org>
+#
+# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
+# This is free software, and you are welcome to redistribute it
+# under certain conditions; see COPYING for details.
+
+set -e
+
+# Including common functions
+. "${LH_BASE:-/usr/share/live-helper}"/scripts/build.sh
+
+# Setting static variables
+DESCRIPTION="$(Echo 'manage /var/lib/dpkg')"
+HELP=""
+USAGE="${PROGRAM} {install|remove} [--force]"
+
+Arguments "${@}"
+
+# Reading configuration files
+Read_conffiles config/all config/common config/bootstrap config/chroot config/binary config/source
+Set_defaults
+
+# Requiring stage file
+Require_stagefile .stage/config .stage/bootstrap
+
+case "${1}" in
+	install)
+		Echo_message "Configuring tmpfs for /var/lib/dpkg"
+
+		# Checking stage file
+		Check_stagefile .stage/chroot_dpkg_tmpfs
+
+		# Checking lock file
+		Check_lockfile .lock
+
+		# Creating lock file
+		Create_lockfile .lock
+
+		mv chroot/var/lib/dpkg chroot/var/lib/dpkg.tmp
+		mkdir chroot/var/lib/dpkg
+		mount -t tmpfs tmpfs chroot/var/lib/dpkg
+		mv chroot/var/lib/dpkg.tmp/* chroot/var/lib/dpkg
+		rm -rf chroot/var/lib/dpkg.tmp
+
+		# Creating stage file
+		Create_stagefile .stage/chroot_dpkg_tmpfs
+		;;
+
+	remove)
+		Echo_message "Deconfiguring tmpfs for /var/lib/dpkg"
+
+		# Checking lock file
+		Check_lockfile .lock
+
+		# Creating lock file
+		Create_lockfile .lock
+
+		mkdir -p chroot/var/lib/dpkg.tmp
+		mv chroot/var/lib/dpkg/* chroot/var/lib/dpkg.tmp
+		umount chroot/var/lib/dpkg
+		rm -rf chroot/var/lib/dpkg
+		mv chroot/var/lib/dpkg.tmp chroot/var/lib/dpkg
+
+		# Removing stage file
+		rm -f .stage/chroot_dpkg_tmpfs
+		;;
+
+	*)
+		Usage
+		;;
+esac
diff --git a/scripts/build/clean b/scripts/build/clean
index 2df040c..13fc185 100755
--- a/scripts/build/clean
+++ b/scripts/build/clean
@@ -79,6 +79,7 @@ do
 			${LH_ROOT_COMMAND} umount -f chroot/dev/shm > /dev/null 2>&1 || true
 			${LH_ROOT_COMMAND} umount -f chroot/dev/pts > /dev/null 2>&1 || true
 			${LH_ROOT_COMMAND} umount -f chroot/dev > /dev/null 2>&1 || true
+			${LH_ROOT_COMMAND} umount -f chroot/var/lib/dpkg > /dev/null 2>&1 || true
 
 			${LH_ROOT_COMMAND} umount -f chroot/binary.tmp > /dev/null 2>&1 || true
 			${LH_ROOT_COMMAND} umount -f chroot/dev.tmp/pts > /dev/null 2>&1 || true
-- 
cgit v1.0